package com.fp.persistence.pgeneral.receive;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TRECEIVABLETEMPLATEDETAIL*/
@Entity(name="TreceivableTemplateDetail")
@Table(name="TRECEIVABLETEMPLATEDETAIL")
public class TreceivableTemplateDetail extends com.fp.dto.AbstractDataBalanceTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TreceivableTemplateDetail
*/
@Id
@Column(name="TEMPLATECODE" ,nullable=false, updatable=false)
private Integer pk;
@Column(name="BALANCETYPE", nullable=false)

/**
* Código de tipo de saldo d registro de la CXC. Efectivo, Bloqueado , Pignorado, Retenciones Locales, remesas ..Etc
*/
private String balancetype;

@Column(name="BALANCEGROUP", nullable=false)

/**
* Codigo del grupo de balance 1 Activo, 2 Pasivo, 3 Patrimonio .. 62 contingente deudor 61 por contra deudor 
*/
private String balancegroup;

@Column(name="RECOVERBALANCETYPE", nullable=true)

/**
* Código de tipo de saldo d cobro de la CXC. Efectivo, Bloqueado , Pignorado, Retenciones Locales, remesas ..Etc
*/
private String recoverbalancetype;

@Column(name="RECOVERBALANCEGROUP", nullable=true)

/**
* Codigo del grupo de balance 1 Activo, 2 Pasivo, 3 Patrimonio .. 62 contingente deudor 61 por contra deudor 
*/
private String recoverbalancegroup;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="PRIORITY", nullable=true)

/**
* Prioridad de cobro de la cuenta por cobrar dentro del dia
*/
private Integer priority;

@Column(name="ISPARTIAL", nullable=true)

/**
* Indica si permite cobros parciales de cuenta por cobrar.
*/
private String ispartial;

@Column(name="MINIMUNPAYMENT", nullable=true)

/**
* Si permite cobro parcial cual es el valor minimo a cobrar.
*/
private BigDecimal minimunpayment;

@Column(name="TERM", nullable=true)

/**
* Plazo de vigencia de la cuenta por cobrar, al vencimiento se da de baja la cxc
*/
private Integer term;

@Column(name="MANAGECACHE", nullable=true)

/**
* Indica si el registro de plantilla se almacena en cache en el servidor de aplicaciones
*/
private String managecache;

/**Contructor por defecto*/
public TreceivableTemplateDetail(){
}
/**Contructor de TreceivableTemplateDetail
@param pPk Clave Primaria del entity
@param pBalancetype Código de tipo de saldo d registro de la CXC. Efectivo, Bloqueado , Pignorado, Retenciones Locales, remesas ..Etc
@param pBalancegroup Codigo del grupo de balance 1 Activo, 2 Pasivo, 3 Patrimonio .. 62 contingente deudor 61 por contra deudor 
*/
public TreceivableTemplateDetail(Integer pPk,String pBalancetype,String pBalancegroup){
 this();
 pk=pPk;
 balancetype=pBalancetype;
 balancegroup=pBalancegroup;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TreceivableTemplateDetail
*/
public static TreceivableTemplateDetail find(EntityManager pEntityManager,Object pKey) throws Exception{
    TreceivableTemplateDetail obj = pEntityManager.find(TreceivableTemplateDetail.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TreceivableTemplateDetail
@return El objeto que referencia a la Clave primaria de TreceivableTemplateDetail
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TreceivableTemplateDetail
@param pPk El objeto que referencia a la nueva Clave primaria de TreceivableTemplateDetail
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de balancetype
@return valor de balancetype*/
public String getBalancetype(){
  return balancetype;
}
/**Fija el valor de balancetype
@param pBalancetype nuevo Valor de balancetype*/
public void setBalancetype(String pBalancetype){
  balancetype=pBalancetype;
}

/**Obtiene el valor de balancegroup
@return valor de balancegroup*/
public String getBalancegroup(){
  return balancegroup;
}
/**Fija el valor de balancegroup
@param pBalancegroup nuevo Valor de balancegroup*/
public void setBalancegroup(String pBalancegroup){
  balancegroup=pBalancegroup;
}

/**Obtiene el valor de recoverbalancetype
@return valor de recoverbalancetype*/
public String getRecoverbalancetype(){
  return recoverbalancetype;
}
/**Fija el valor de recoverbalancetype
@param pRecoverbalancetype nuevo Valor de recoverbalancetype*/
public void setRecoverbalancetype(String pRecoverbalancetype){
  recoverbalancetype=pRecoverbalancetype;
}

/**Obtiene el valor de recoverbalancegroup
@return valor de recoverbalancegroup*/
public String getRecoverbalancegroup(){
  return recoverbalancegroup;
}
/**Fija el valor de recoverbalancegroup
@param pRecoverbalancegroup nuevo Valor de recoverbalancegroup*/
public void setRecoverbalancegroup(String pRecoverbalancegroup){
  recoverbalancegroup=pRecoverbalancegroup;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de priority
@return valor de priority*/
public Integer getPriority(){
  return priority;
}
/**Fija el valor de priority
@param pPriority nuevo Valor de priority*/
public void setPriority(Integer pPriority){
  priority=pPriority;
}

/**Obtiene el valor de ispartial
@return valor de ispartial*/
public String getIspartial(){
  return ispartial;
}
/**Fija el valor de ispartial
@param pIspartial nuevo Valor de ispartial*/
public void setIspartial(String pIspartial){
  ispartial=pIspartial;
}

/**Obtiene el valor de minimunpayment
@return valor de minimunpayment*/
public BigDecimal getMinimunpayment(){
  return minimunpayment;
}
/**Fija el valor de minimunpayment
@param pMinimunpayment nuevo Valor de minimunpayment*/
public void setMinimunpayment(BigDecimal pMinimunpayment){
  minimunpayment=pMinimunpayment;
}

/**Obtiene el valor de term
@return valor de term*/
public Integer getTerm(){
  return term;
}
/**Fija el valor de term
@param pTerm nuevo Valor de term*/
public void setTerm(Integer pTerm){
  term=pTerm;
}

/**Obtiene el valor de managecache
@return valor de managecache*/
public String getManagecache(){
  return managecache;
}
/**Fija el valor de managecache
@param pManagecache nuevo Valor de managecache*/
public void setManagecache(String pManagecache){
  managecache=pManagecache;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TreceivableTemplateDetail))return false;
    TreceivableTemplateDetail that = (TreceivableTemplateDetail) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TreceivableTemplateDetail
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TreceivableTemplateDetail
*/
public Object createInstance(){
 TreceivableTemplateDetail instance=new TreceivableTemplateDetail();	
 return instance;
}
/**Clona la entidad TreceivableTemplateDetail
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TreceivableTemplateDetail p=(TreceivableTemplateDetail)this.clone();
  return p;
}
}
